''
''
'' fbn00b tutorial - tutorial 4, UDT example:  recipes
''
''

'This shows the power yet simplicity of UDTs and arrays, and demonstrates
'all the major programming techniques learned up until now.  It is, however,
'nothing more than a modified version of the peoples list.

 Type ingredient
   As String iname
   As Integer amt
   As String units
 End Type

 Type recipe
    recipe_name As String
    ingredient(30) As ingredient
    num_ingredients As Integer
    instructions As String
  End Type
  
  Redim As recipe my_recipes(1)  
  Dim As Integer nrecipes, i, j
  Dim As String tingr_amt, tingr_name

  Print "How many recipes do you wish to input?"
  Input nrecipes

  Redim my_recipes(nrecipes)

  For i = 1 To nrecipes
    Print "Recipe #" + Str(i)
    Print "Recipe name?"
    Input my_recipes(i).recipe_name
    Print "How many ingredients in the ingredients list?"
    Input my_recipes(i).num_ingredients
    
    If my_recipes(i).num_ingredients > 30 Then
      Print "Sorry, no more than 30 ingredients are allowed."
      my_recipes(i).num_ingredients = 30
    End If
    
    For j = 1 To my_recipes(i).num_ingredients
      Print "Ingredient #" + Str(j)
      Print "What is the ingredient?"
      Input my_recipes(i).ingredient(j).iname
      Print "How much of the ingredient?  Do not include the units indicator."
      Input my_recipes(i).ingredient(j).amt
      Print "What measurement units is this ingredient measured in?"
      Input my_recipes(i).ingredient(j).units
    Next j
    
    Print "Now enter preparation instructions.  Do not press Enter until you're done."
    Input my_recipes(i).instructions
  Next i

  Do
    Print "Which recipe ID number would you like to see?  Press 0 to exit."
    Input i

    If i = 0 Then
      Print "Press any key to exit..."
      Sleep
      Cls
      End
    Else
      Print "----------------------------------------------------------------"
      Print ""
      Print my_recipes(i).recipe_name
      Print ""
      For j = 1 To my_recipes(i).num_ingredients
        Print Str(my_recipes(i).ingredient(j).amt) + " " + my_recipes(i).ingredient(j).units + " " + my_recipes(i).ingredient(j).iname
      Next j
      Print ""
      Print my_recipes(i).instructions
      Print ""
      Print "----------------------------------------------------------------"
    End If

  'This is an infinity loop!  However, there is a way to break out, if you enter 0.
  Loop